(function ($, window) {
    //显示加载框
    $.showLoading = function (message) {

        var html = '';
        html += '<i class="mui-spinner mui-spinner-white"></i>';
        html += '<p class="text">' + (message || "数据加载中") + '</p>';

        //遮罩层
        var mask = document.getElementsByClassName("mui-show-loading-mask");
        if (mask.length == 0) {
            mask = document.createElement('div');
            mask.classList.add("mui-show-loading-mask");
            document.body.appendChild(mask);
            mask.addEventListener("touchmove", function (e) {
                e.stopPropagation();
                e.preventDefault();
            });
        } else {
            mask[0].classList.remove("mui-show-loading-mask-hidden");
        }
        //加载框
        var toast = document.getElementsByClassName("mui-show-loading");
        if (toast.length == 0) {
            toast = document.createElement('div');
            toast.classList.add("mui-show-loading");
            toast.classList.add('loading-visible');
            document.body.appendChild(toast);
            toast.innerHTML = html;
            toast.addEventListener("touchmove", function (e) {
                e.stopPropagation();
                e.preventDefault();
            });
        } else {
            toast[0].innerHTML = html;
            toast[0].classList.add("loading-visible");
        }

    };

    //隐藏加载框
    $.hideLoading = function (callback) {
        var mask = document.getElementsByClassName("mui-show-loading-mask");
        var toast = document.getElementsByClassName("mui-show-loading");
        if (mask.length > 0) {
            mask[0].classList.add("mui-show-loading-mask-hidden");
        }
        if (toast.length > 0) {
            toast[0].classList.remove("loading-visible");
        }
        callback && callback();
    }

    "use strict";
    var auiToast = function () {
        // this.create();
    };
    auiToast.prototype = {
        create: function (params, callback) {
            var self = this;
            var iconHtml = "";
            switch (params.type) {
                case "success":
                    iconHtml = '<i class="mui-icon mui-icon-checkmarkempty"></i>';
                    break;
                case "fail":
                    iconHtml = '<i class="mui-icon mui-icon-closeempty"></i>';
                    break;
                case "custom":
                    iconHtml = params.html;
                    break;
            }
            var titleHtml = params.title ? '<div class="aui-toast-content">' + params.title + '</div>' : '';
            var toastHtml = '<div class="aui-toast">' + iconHtml + titleHtml + '</div>';
            if (document.querySelector(".aui-toast"))return;
            document.body.insertAdjacentHTML('beforeend', toastHtml);
            var duration = params.duration ? params.duration : 2000;
            self.show();
            setTimeout(function () {
                self.hide();
                if (callback) callback({
                    status: "success"
                });
            }, duration)
        },
        show: function () {
            document.querySelector(".aui-toast").style.display = "block";
            document.querySelector(".aui-toast").style.marginTop = "-" + Math.round(document.querySelector(".aui-toast").offsetHeight / 2) + "px";
            if (document.querySelector(".aui-toast"))return;
        },
        hide: function () {
            if (document.querySelector(".aui-toast")) {
                document.querySelector(".aui-toast").parentNode.removeChild(document.querySelector(".aui-toast"));
            }
        },
        remove: function () {
            if (document.querySelector(".aui-dialog"))document.querySelector(".aui-dialog").parentNode.removeChild(document.querySelector(".aui-dialog"));
            if (document.querySelector(".aui-mask")) {
                document.querySelector(".aui-mask").classList.remove("aui-mask-out");
            }
            return true;
        },
        success: function (title, duration, callback) {
            console.log(this);
            var self = this;
            var params = {
                title: title || "成功",
                duration: duration || 2000,
                type: "success"
            };
            return self.create(params, callback);
        },
        fail: function (title, duration, callback) {
            var self = this;
            var params = {
                title: title || "失败",
                duration: duration || 3000,
                type: "fail"
            };
            return self.create(params, callback);
        },
        custom: function (title, duration, html, callback) {
            var self = this;
            var params = {
                title: title || "失败",
                duration: duration || 3000,
                html: html,
                type: "custom"
            };
            return self.create(params, callback);
        }
    };
    $.aui = new auiToast();
})(mui, window);
